_sql_initPhrases = """
<dtml-if dropFirst>
  DROP SEQUENCE Phrases_phrase_id_seq;
  DROP TABLE Phrases;
</dtml-if>

CREATE TABLE Phrases ( 
	phrase_id        SERIAL,
	lang             varchar( 16) NOT NULL,
	md5Hash          varchar( 32) NOT NULL,
	renderPath       varchar(255) NOT NULL,
	renderText       text         NOT NULL);
"""


_qry_findMatches = """
SELECT *
  FROM Phrases
  WHERE md5Hash=<dtml-sqlvar md5Hash type=nb>
"""


_sql_newPhrase = """
INSERT
  INTO Phrases (lang, md5hash, renderpath, rendertext)
  VALUES (<dtml-sqlvar lang type=nb>,
          <dtml-sqlvar md5Hash type=nb>,
          <dtml-sqlvar renderPath type=nb>,
          <dtml-sqlvar renderText type=nb> )
"""


_qry_getPages = """
SELECT DISTINCT renderPath
  FROM Phrases
  ORDER BY renderPath
"""


_qry_getAllPhrases = """
SELECT *
  FROM Phrases
  ORDER BY renderPath
"""


_qry_getPhrasesByPage = """
SELECT *
  FROM Phrases
  WHERE
    renderPath=<dtml-sqlvar renderPath type=nb> AND
    ( lang=<dtml-sqlvar srcLang type=nb> OR
      lang=<dtml-sqlvar dstLang type=nb> )
  ORDER BY md5Hash
"""


_qry_getLanguages = """
SELECT DISTINCT lang
  FROM Phrases
"""


_qry_getmd5Hashes = """
SELECT DISTINCT md5hash
  FROM Phrases
  WHERE lang = <dtml-sqlvar srcLang type=nb>
"""


_sql_updatePhrase = """
UPDATE Phrases
  SET renderText = <dtml-sqlvar renderText type=nb>
  WHERE phrase_id = <dtml-sqlvar phrase_id type=int>
"""


_qry_getPhrasesToUpdate = """
SELECT Phrases.*
  FROM phrases
  WHERE md5hash NOT IN (
    SELECT md5hash
      FROM phrases
      WHERE lang=<dtml-sqlvar dstLang type=nb> )
    AND lang = <dtml-sqlvar srcLang type=nb> ;
"""


#### This is label stuff ####

_qry_getLabelLanguages = """
SELECT DISTINCT lang
  FROM Phrases
  WHERE md5hash IN (
    SELECT md5hash
      FROM Phrases
      WHERE lang = 'label')
    AND lang != 'label'
"""


_qry_getLabels = """
SELECT *
  FROM Phrases
  WHERE lang = 'label'
  <dtml-unless "text == ''">
    and rendertext LIKE <dtml-sqlvar text type="string">
  </dtml-unless>
"""

_sql_deleteLanguage = """
DELETE FROM Phrases
WHERE <dtml-sqltest lang type="string">
"""

_qry_getLabelByLangAndLabelId = """
SELECT *
  FROM Phrases
  WHERE <dtml-sqltest lang type="string">
    AND md5hash IN (
      SELECT md5hash
        FROM phrases
        WHERE phrase_id = <dtml-sqlvar phrase_id type="int">);
"""

_sql_updateLabel = """
UPDATE phrases
  SET rendertext = <dtml-sqlvar text type="string">
  WHERE <dtml-sqltest lang type="string">
    AND md5hash IN (
      SELECT md5hash
        FROM phrases
        WHERE phrase_id = <dtml-sqlvar phrase_id type="int">);
"""


_sql_deleteLabel = """
DELETE FROM phrases
  WHERE md5hash IN (
      SELECT md5hash
        FROM phrases
        WHERE phrase_id = <dtml-sqlvar phrase_id type="int">);
"""



